# logistic map: time and cobweb plots

f.x<- function(x,r){
  r*x*(1-x)
}
##### function to draw the time plot #####
f.temp<-function(xinit,nstep,r){   # starting function f.temp
  xt<- numeric()
  x<- xinit
  xt[1]<- x
  for(i in 2:nstep){
    y<- f.x(x,r)
    x<- y
    xt[i]<- x
  }
  plot(xt,type="b",xlab="time",ylab="x(t)",
       cex.lab=1.7,cex.axis=1.3,lwd=2)
  #xt            # comment to skip iterates
}   # ending function f.temp
##### function to draw the cobweb plot ####
iter<- function(xinit,nstep,r){    # starting function iter
  x<- xinit
  y<- f.x(x,r)
  segments(x,0,x,y,lty=1,lwd=2)
  for(i in 1:nstep){
    points(x,y,pch=19,cex=1.5)
    segments(x,y,y,y,lty=1,lwd=2)
    x<- y
    y<- f.x(x,r)
    segments(x,x,x,y,lty=1,lwd=2)
  }
}    # ending function iter
### parameters and initial conditions
r<- 3.2
#vary r: r<- 2.8,  r<- 3.2,  r<- 3.5,  r<- 4
xinit<- 0.01
nstep<- 25
# nstep<- 25: r=2.8, 3.2; nstep<- 50:  r=3.5, 4
f.temp(xinit,nstep,r)                   # I ask the time plot
### preparation of the cobweb plot
windows()
plot(1,1,type="n",xlim=c(0,1),ylim=c(0,1),xlab="x(t)",ylab="x(t+1)",
     cex.lab=1.5,cex.axis=1.2)
curve(f.x(x,r),from = 0, to = 1,lty=5,lwd=2,col="black",add=T)  # plot of the function f.x
segments(0,0,1,1,lty=3,lwd=2,col="black")                    # bisector
# more aesthetically: col="blue" and col="magenta"
iter(xinit,nstep,r)                           # I ask  the cobweb plot
